﻿Imports System.ComponentModel
Imports System.Globalization
Imports System.Runtime.CompilerServices

Public Class BindToCodebehind
    Implements INotifyPropertyChanged

    Private Sub BindToClassFromCode_Loaded(sender As Object, e As RoutedEventArgs) Handles Me.Loaded
        Me.DataContext = Me
        TestProperty = "Hallo Welt!"
    End Sub


    Private _testProperty As String
    Public Property TestProperty() As String
        Get
            Debug.WriteLine($"Variabe wird abgerufen. Der abgerufene Wert: '{_testProperty}'")
            Return _testProperty
        End Get
        Set(ByVal value As String)
            Debug.WriteLine($"Variable wird geändert von '{_testProperty}' zu '{value}'")
            _testProperty = value
            RaisePropertyChanged()
            Debug.WriteLine("Variable geändert und PropertyChanged geworfen.")
        End Set
    End Property





    Protected Overridable Sub RaisePropertyChanged(<CallerMemberName> Optional ByVal prop As String = "")
        RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(prop))
    End Sub

    Public Event PropertyChanged As PropertyChangedEventHandler Implements INotifyPropertyChanged.PropertyChanged

    Private Sub SetTestProperty(sender As Object, e As RoutedEventArgs)
        TestProperty = DateTime.Now.ToString("F", CultureInfo.CurrentCulture)
    End Sub
End Class
