﻿Imports System.ComponentModel
Imports System.Runtime.CompilerServices

Namespace TestClasses
    Public Class Meeting
        Implements INotifyPropertyChanged

        Public Sub New()

        End Sub


        Public Sub New(title As String, starttime As DateTime, duration As TimeSpan)
            Me.Title = title
            Me.StartTime = starttime
            Me.Duration = duration
        End Sub

        Private _title As String
        Public Property Title() As String
            Get
                Return _title
            End Get
            Set(ByVal value As String)
                _title = value
                RaisePropertyChanged()
            End Set
        End Property

        Private _startTime As DateTime

        Public Property StartTime() As DateTime
            Get
                Return _startTime
            End Get
            Set(ByVal value As DateTime)
                _startTime = value
                RaisePropertyChanged()
            End Set
        End Property

        Private _duration As TimeSpan

        Public Property Duration() As TimeSpan
            Get
                Return _duration
            End Get
            Set(ByVal value As TimeSpan)
                _duration = value
                RaisePropertyChanged()
            End Set
        End Property



        Protected Overridable Sub RaisePropertyChanged(<CallerMemberName> Optional ByVal prop As String = "")
            RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(prop))
        End Sub

        Public Event PropertyChanged As PropertyChangedEventHandler Implements INotifyPropertyChanged.PropertyChanged
    End Class
End Namespace
